package com.ccnode.codegenerator.A;

package .tmp;

import com.ccnode.codegenerator.G.a;
import com.ccnode.codegenerator.G.c;
import com.ccnode.codegenerator.dom.model.Mapper;
import com.ccnode.codegenerator.dom.model.ResultMap;
import com.ccnode.codegenerator.dom.model.Select;
import com.ccnode.codegenerator.dom.model.Sql;
import com.ccnode.codegenerator.k.a;
import com.google.common.base.Stopwatch;
import com.intellij.openapi.fileTypes.FileType;
import com.intellij.openapi.fileTypes.StdFileTypes;
import com.intellij.openapi.project.Project;
import com.intellij.psi.xml.XmlFile;
import com.intellij.psi.xml.XmlTag;
import com.intellij.util.ObjectUtils;
import com.intellij.util.indexing.DataIndexer;
import com.intellij.util.indexing.DefaultFileTypeSpecificInputFilter;
import com.intellij.util.indexing.FileBasedIndex;
import com.intellij.util.indexing.FileContent;
import com.intellij.util.indexing.ID;
import com.intellij.util.indexing.IndexId;
import com.intellij.util.indexing.ScalarIndexExtension;
import com.intellij.util.io.EnumeratorStringDescriptor;
import com.intellij.util.io.KeyDescriptor;
import com.intellij.util.xml.DomElement;
import com.intellij.util.xml.DomManager;
import gnu.trove.THashMap;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import org.apache.commons.lang3.StringUtils;
import org.jetbrains.annotations.NotNull;

public class b extends ScalarIndexExtension<String> {
  public static final ID<String, Void> a = ID.create("MybatisCodeHelperIndexer6");
  
  private static a a = c.a.a(com.ccnode.codegenerator.A.b.class);
  
  public static final String a = "java.min$##.myMapperLocations.mapper_666";
  
  public static final String b = "MybatisMapperNameSpace@";
  
  public static final String c = "MybatisResultMapId@";
  
  public static final String d = "MybatisSqlId@";
  
  public static final String e = "MybatisFilePath@";
  
  public static final String f = "MybatisSelectReferenceResultMapId@";
  
  private final DataIndexer<String, Void, FileContent> a = (DataIndexer<String, Void, FileContent>)new Object(this);
  
  private Map<String, Void> a(Stopwatch paramStopwatch, XmlFile paramXmlFile, Project paramProject, XmlTag paramXmlTag, FileContent paramFileContent) {
    String str1 = paramFileContent.getFile().getPath();
    if (!paramXmlTag.getName().equals("mapper"))
      return Collections.emptyMap(); 
    String str2 = paramXmlTag.getAttributeValue("namespace");
    if (StringUtils.isBlank(str2))
      return Collections.emptyMap(); 
    THashMap<Object, Object> tHashMap = new THashMap<>();
    tHashMap.put("MybatisMapperNameSpace@" + str2, null);
    tHashMap.put("java.min$##.myMapperLocations.mapper_666", null);
    tHashMap.put("MybatisFilePath@" + str1, null);
    for (XmlTag xmlTag : paramXmlTag.getSubTags()) {
      String str = xmlTag.getName();
      if (str.equals("resultMap")) {
        String str3 = xmlTag.getAttributeValue("id");
        tHashMap.put("MybatisResultMapId@" + str2 + "." + str3, null);
      } else if (str.equals("sql")) {
        String str3 = xmlTag.getAttributeValue("id");
        tHashMap.put("MybatisSqlId@" + str2 + "." + str3, null);
      } else if (str.equals("select")) {
        String str3 = xmlTag.getAttributeValue("resultMap");
        if (str3 != null)
          if (str3.contains(".")) {
            tHashMap.put("MybatisSelectReferenceResultMapId@" + str3, null);
          } else {
            tHashMap.put("MybatisSelectReferenceResultMapId@" + str2 + "." + str3, null);
          }  
      } 
    } 
    if (a.a().getShowIndexTimeUsage()) {
      long l = paramStopwatch.elapsed(TimeUnit.MICROSECONDS);
      System.out.println("build from xml file time used in MICROSECONDS for " + paramXmlFile.getName() + " is: " + l + " MICROSECONDS");
    } 
    return (Map)tHashMap;
  }
  
  @NotNull
  private Map<String, Void> b(Stopwatch paramStopwatch, XmlFile paramXmlFile, Project paramProject, XmlTag paramXmlTag, FileContent paramFileContent) {
    DomElement domElement = DomManager.getDomManager(paramProject).getDomElement(paramXmlTag);
    if (domElement == null)
      return Collections.emptyMap(); 
    Mapper mapper = (Mapper)ObjectUtils.tryCast(domElement, Mapper.class);
    if (mapper == null)
      return Collections.emptyMap(); 
    String str = mapper.getNamespace().getStringValue();
    if (str != null) {
      THashMap<Object, Object> tHashMap = new THashMap<>();
      tHashMap.put("MybatisMapperNameSpace@" + str, null);
      tHashMap.put("java.min$##.myMapperLocations.mapper_666", null);
      tHashMap.put("MybatisFilePath@" + paramFileContent.getFile().getPath(), null);
      List list = mapper.getResultMaps();
      for (ResultMap resultMap : list) {
        String str1 = resultMap.getId().getStringValue();
        tHashMap.put("MybatisResultMapId@" + str + "." + str1, null);
      } 
      for (Sql sql : mapper.getSqls()) {
        String str1 = sql.getId().getStringValue();
        tHashMap.put("MybatisSqlId@" + str + "." + str1, null);
      } 
      for (Select select : mapper.getSelects()) {
        String str1 = select.getResultMap().getStringValue();
        if (str1 != null) {
          if (str1.contains(".")) {
            tHashMap.put("MybatisSelectReferenceResultMapId@" + str1, null);
            continue;
          } 
          tHashMap.put("MybatisSelectReferenceResultMapId@" + str + "." + str1, null);
        } 
      } 
      if (a.a().getShowIndexTimeUsage()) {
        long l = paramStopwatch.elapsed(TimeUnit.MICROSECONDS);
        System.out.println("mapper file time used in MICROSECONDS for " + paramXmlFile.getName() + " is: " + l + " MICROSECONDS");
      } 
      return (Map)tHashMap;
    } 
    return Collections.emptyMap();
  }
  
  @NotNull
  public ID<String, Void> getName() {
    return (ID)a;
  }
  
  @NotNull
  public DataIndexer<String, Void, FileContent> getIndexer() {
    return this.a;
  }
  
  @NotNull
  public KeyDescriptor<String> getKeyDescriptor() {
    return (KeyDescriptor<String>)EnumeratorStringDescriptor.INSTANCE;
  }
  
  public int getVersion() {
    return 7;
  }
  
  @NotNull
  public FileBasedIndex.InputFilter getInputFilter() {
    return (FileBasedIndex.InputFilter)new DefaultFileTypeSpecificInputFilter(new FileType[] { (FileType)StdFileTypes.XML });
  }
  
  public boolean dependsOnFileContent() {
    return true;
  }
}
